<?php

if(isset($_SERVER['REMOTE_ADDR'])) die();
include_once('../../global.php');

$BaseDomain = 'zdechov.net';
$Serial = date('Ymds', time());
$MinimumTime = 7200;
$RetryTime = 7200;
$ExpireTime = 2419200;
$RefreshTime = 28800;
$MinimumTime = 10800;
$BaseDir = '/var/named/chroot/var/named/';
$MailServer = 'centrala';
$NameServers = array('centrala', 'tv');

// === Local network DNS server ===

// Generate DNS records
$File = fopen($BaseDir.'internal/'.$BaseDomain.'.zone', 'w');
fputs($File,'$ORIGIN '.$BaseDomain.'.'."\n".
'$TTL 86400'."\n".
$BaseDomain.".\tIN\tSOA\t".$NameServers[0].".".$BaseDomain.".\troot.".$BaseDomain.".	(\n".
"\t\t\t".$Serial."\t; serial\n".
"\t\t\t".$RefreshTime."\t; refresh\n".
"\t\t\t".$RetryTime."\t; retry\n".
"\t\t\t".$ExpireTime."\t; expire\n".
"\t\t\t".$MinimumTime."\t; minimum\n".
"\t\t\t)\n".
"\t\tIN\tNS\t".$NameServers[0].".".$BaseDomain.".\n".
"\t\tIN\tNS\t".$NameServers[1].".".$BaseDomain.".\n".
"\t\t\tTXT\t".'"community network ZdechovNET"'."\n".
// "\t\tIN\tA\t192.168.0.1\n".
"\t\t\tMX\t10 ".$MailServer.".".$BaseDomain.".\n");

$DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetwordInterface.Device WHERE NetworkInterface.LocalIP <> ""');
while($Interface = $DbResult->fetch_assoc())
{
  $Name = $Interface['DeviceName'];
  if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
  $Name = strtolower($Name);
  if(strlen($Name) < 8) $Name .= "\t";
  fputs($File, $Name."\tIN\tA\t".$Interface['LocalIP']."\n");
}

// External records in internal server
$DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetwordInterface.Device WHERE NetworkInterface.ExternalIP <> ""');
while($Interface = $DbResult->fetch_assoc())
{
  $Name = $Interface['DeviceName'];
  if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
  $Name = strtolower($Name.'-ext');
  if(strlen($Name) < 8) $Name .= "\t";
  fputs($File, $Name."\tIN\tA\t".$Interface['ExternalIP']."\n");
}

$DbResult = $Database->select('NetworkDomainAlias', '*');
while($Alias = $DbResult->fetch_assoc())
{
  $Data = strtolower($Alias['Name']);
  if(strlen($Data) < 8) $Data .= "\t";
  fputs($File, $Data."\tIN\tCNAME\t".$Alias['Target']."\n");
}

fclose($File);

// Generate reverse DNS records
$Networks = array('192.168.0', '192.168.1', '192.168.2', '192.168.3', '192.168.4', '192.168.5', '192.168.6', '192.168.7');
foreach($Networks as $Network)
{
  $Parts = explode('.', $Network);
  $File = fopen($BaseDir.'internal/'.$Parts[2].'.'.$Parts[1].'.'.$Parts[0].'.in-addr.arpa.zone', 'w+');
  fputs($File,
  '$TTL 86400'."\n".
  "@\tIN\tSOA\t".$NameServers[0].".".$BaseDomain.".\troot.".$BaseDomain.".	(\n".
  "\t\t\t\t".$Serial."\t; serial\n".
  "\t\t\t\t".$RefreshTime."\t; refresh\n".
  "\t\t\t\t".$RetryTime."\t; retry\n".
  "\t\t\t\t".$ExpireTime."\t; expire\n".
  "\t\t\t\t".$MinimumTime."\t; minimum\n".
  "\t\t\t\t)\n".
  "@\tIN\tNS\t".$NameServers[0].".".$BaseDomain.".\n".
  "\tIN\tNS\t".$NameServers[1].".".$BaseDomain.".\n\n");
  $DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetworkInterface.Device WHERE NetworkInterface.LocalIP LIKE "'.$Network.'%"');
  while($Interface = $DbResult->fetch_assoc())
  {
    $Name = $Interface['DeviceName'];
    if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
    $Name = strtolower($Name.'-ext');
    $IP = explode('.', $Interface['LocalIP']);
    fputs($File, $IP[3]."\tIN\tPTR\t".strtolower($Name).".zdechov.net.\n");
  }
  fclose($File);
}

// Generate reverse DNS records
$Networks = array('85.92.50');
foreach($Networks as $Network)
{
  $Parts = explode('.', $Network);
  $File = fopen($BaseDir.'internal/'.$Parts[2].'.'.$Parts[1].'.'.$Parts[0].'.in-addr.arpa.zone', 'w+');
  fputs($File,
  '$TTL 86400'."\n".
  "@\tIN\tSOA\t".$NameServers[0].".".$BaseDomain.".\troot.".$BaseDomain.".	(\n".
  "\t\t\t\t".$Serial."\t; serial\n".
  "\t\t\t\t".$RefreshTime."\t; refresh\n".
  "\t\t\t\t".$RetryTime."\t; retry\n".
  "\t\t\t\t".$ExpireTime."\t; expire\n".
  "\t\t\t\t".$MinimumTime."\t; minimum\n".
  "\t\t\t\t)\n".
  "@\tIN\tNS\t".$NameServers[0].".".$BaseDomain.".\n".
  "\tIN\tNS\t".$NameServers[1].".".$BaseDomain.".\n\n");
  $DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetworkInterface.Device WHERE NetworkInterface.ExternalIP LIKE "'.$Network.'%"');
  while($Interface = $DbResult->fetch_assoc())
  {
    $Name = $Interface['DeviceName'];
    if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
    $Name = strtolower($Name.'-ext');
    $IP = explode('.',$Interafce['ExternalIP']);
    fputs($File, $IP[3]."\tIN\tPTR\t".strtolower($Name])."-ext.".$BaseDomain.".\n");
  }
  fclose($File);
}

// === External network DNS server ===

// Generate DNS records
$File = fopen($BaseDir.'external/'.$BaseDomain.'.zone', 'w');
$Header = '$ORIGIN '.$BaseDomain.'.'."\n".
'$TTL 86400'."\n".
$BaseDomain.".\tIN\tSOA\t".$NameServers[0].".".$BaseDomain.".\troot.".$BaseDomain.".	(\t\n".
"\t\t\t".$Serial."\t; serial\n".
"\t\t\t".$RefreshTime."\t; refresh\n".
"\t\t\t".$RetryTime."\t; retry\n".
"\t\t\t".$ExpireTime."\t; expire\n".
"\t\t\t".$MinimumTime."\t; minimum\n".
"\t\t\t)\n".
"\t\t\tTXT\t".'"community network ZdechovNET"'."\n".
"\t\tIN\tNS\t".$NameServers[0].".".$BaseDomain.".\n".
"\t\tIN\tNS\t".$NameServers[1].".".$BaseDomain.".\n".
"\t\tIN\tNS\tplandsfeld.avonet.cz.\n";
// "\t\tIN\tA\t81.2.194.142\n".
$Header .= "\t\t\tMX\t10 ".$MailServer.".".$BaseDomain.".\n".
"; SPF\n".
"zdechov.net.\tIN\tTXT\t\"v=spf1 mx -all\"\n".
"zdechov.net.\tIN\tSPF\t\"v=spf1 mx -all\"\n".
"centrala\tIN\tTXT\t\"v=spf1 a -all\"\n".
"centrala\tIN\tSPF\t\"v=spf1 a -all\"\n".
"; Host list\n";

fputs($File, $Header);

$DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetworkInterface.Device WHERE NetworkInterface.ExternalIP != ""');
while($Interface = $DbResult->fetch_assoc())
{
  $Name = $Interface['DeviceName'];
  if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
  $Name = strtolower($Name);
  if(strlen($Name) < 8) $Name .= "\t";
  fputs($File, $Name."\tIN\tA\t".$Interface['ExternalIP']."\n");
}

$DbResult = $Database->query('SELECT NetworkDomainAlias.* FROM `NetworkDomainAlias`'); 
// JOIN `NetworkDevice` ON NetworkDomainAlias.Target LIKE NetworkDevice.Name AND NetworkInterface.ExternalIP != ""');
while($Alias = $DbResult->fetch_assoc())
{
  $Data = strtolower($Alias['Name']);
  if(strlen($Data) < 8) $Data .= "\t";
  fputs($File, $Data."\tIN\tCNAME\t".$Alias['Target']."\n");
}

fclose($File);

// Generate reverse DNS records
$Networks = array('85.92.50', '81.2.194', '193.86.238', '212.111.4');
foreach($Networks as $Network)
{
  $Parts = explode('.', $Network);
  $File = fopen($BaseDir.'external/'.$Parts[2].'.'.$Parts[1].'.'.$Parts[0].'.in-addr.arpa.zone', 'w+');
  fputs($File,
  '$TTL 86400'."\n".
  "@\tIN\tSOA\t".$NameServers[0].".".$BaseDomain.".\troot.".$BaseDomain.".	(\n".
  "\t\t\t\t".$Serial."\t; serial\n".
  "\t\t\t\t".$RefreshTime."\t; refresh\n".
  "\t\t\t\t".$RetryTime."\t; retry\n".
  "\t\t\t\t".$ExpireTime."\t; expire\n".
  "\t\t\t\t".$MinimumTime."\t; minimum\n".
  "\t\t\t\t)\n".
  "@\tIN\tNS\t".$NameServers[0].".".$BaseDomain.".\n\n".
  "\t\t\tNS\tplandsfeld.avonet.cz.\n".
  "\t\t\tNS\t".$NameServers[1].".".$BaseDomain.".\n");

  $DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetwordInterface.Device WHERE NetworkInterface.ExternalIP LIKE "'.$Network.'.%"');
  while($Interface = $DbResult->fetch_assoc())
  {
    $Name = $Interface['DeviceName'];
    if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
    $Name = strtolower($Name);
    if(strlen($Name) < 8) $Name .= "\t";
    $IP = explode('.', $Interface['ExternalIP']);
    fputs($File, $IP[3]."\tIN\tPTR\t".strtolower($Interface['Name']).".".$BaseDomain.".\n");
  }

  fclose($File);
}

// === CZFree network DNS server ===
$Domain = 'zdechov.zlin.czf';

// Generate DNS records
$File = fopen($BaseDir.'czfree/zdechov.zlin.czf.zone', 'w');
$File2 = fopen($BaseDir.'internal/zdechov.zlin.czf.zone', 'w');

$Header = '$ORIGIN zdechov.zlin.czf.'."\n".
'$TTL 86400'."\n".
$Domain.".\tIN\tSOA\t".$NameServers[0].".".$Domain.".\troot.".$Domain."	(\n".
"\t\t\t".$Serial."\t; serial\n".
"\t\t\t".$RefreshTime."\t; refresh\n".
"\t\t\t".$RetryTime."\t; retry\n".
"\t\t\t".$ExpireTime."\t; expire\n".
"\t\t\t".$MinimumTime."\t; minimum\n".
"\t\t\t)\n".
"\t\t\tTXT\t".'"Community network ZdechovNET"'."\n".
"\t\t\tNS\t".$NameServers[0].".".$Domain.".\n".
"\t\t\tNS\t".$NameServers[1].".".$Domain.".\n".
"\t\t\tNS\tserver.zlin.czf.\n";
"\t\t\tMX\t10 ".$MailServer.".".$Domain.".\n";

fputs($File, $Header);

$Header = '$ORIGIN zdechov.zlin.czf.'."\n".
'$TTL 86400'."\n".
$Domain.".\tIN\tSOA\t".$NameServers[0].".".$Domain.".\troot.".$Domain."	(\n".
"\t\t\t".$Serial."\t; serial\n".
"\t\t\t".$RefreshTime."\t; refresh\n".
"\t\t\t".$RetryTime."\t; retry\n".
"\t\t\t".$ExpireTime."\t; expire\n".
"\t\t\t".$MinimumTime."\t; minimum\n".
"\t\t\t)\n".
"\t\t\tTXT\t".'"Community network ZdechovNET"'."\n".
"\t\t\tNS\t".$NameServers[0].".".$Domain.".\n".
"\t\t\tNS\t".$NameServers[1].".".$Domain.".\n".
"\t\t\tNS\tserver.zlin.czf.\n";
"\t\t\tMX\t10 ".$MailServer.".".$Domain.".\n";
fputs($File2, $Header);

$DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetworkInterface.Device WHERE NetworkInterface.CZFreeIP != ""');
while($Interface = $DbResult->fetch_assoc())
{
  $Name = $Interface['DeviceName'];
  if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
  $Name = strtolower($Name);
  if(strlen($Name) < 8) $Name .= "\t";
  fputs($File, $Name."\tIN\tA\t".$Interface['CZFreeIP']."\n");
  fputs($File2, $Name."\tIN\tA\t".$Interface['LocalIP']."\n");
  $Name .= '-czfree';
  fputs($File2, $Name."\tIN\tA\t".$Interface['CZFreeIP']."\n");
}

$DbResult = $Database->query('SELECT NetworkDomainAlias.* FROM `NetworkDomainAlias` JOIN `hosts`  ON NetworkDomainAlias.Target LIKE hosts.name AND hosts.czfree_ip != ""');
while($Alias = $DbResult->fetch_assoc())
{
  $Data = $Alias['Name'];
  if(strlen($Data) < 8) $Data .= "\t";
  fputs($File, $Data."\tIN\tCNAME\t".$Alias['Target']."\n");
  fputs($File2, $Data."\tIN\tCNAME\t".$Alias['Target']."\n");
}
fclose($File);
fclose($File2);

// Generate reverse DNS records
$Networks = array('10.144.200');
foreach($Networks as $Network)
{
  $Parts = explode('.', $Network);
  $File = fopen($BaseDir.'czfree/'.$Parts[2].'.'.$Parts[1].'.'.$Parts[0].'.in-addr.arpa.zone', 'w+');
  $File2 = fopen($BaseDir.'internal/'.$Parts[2].'.'.$Parts[1].'.'.$Parts[0].'.in-addr.arpa.zone', 'w+');
  $Header = '$TTL 86400'."\n".
  "@\tIN\tSOA\t".$NameServers[0].".".$Domain.".\troot.".$Domain.".	(\n".
  "\t\t\t\t".$Serial."\t; serial\n".
  "\t\t\t\t".$RefreshTime."\t; refresh\n".
  "\t\t\t\t".$RetryTime."\t; retry\n".
  "\t\t\t\t".$ExpireTime."\t; expire\n".
  "\t\t\t\t".$MinimumTime."\t; minimum\n".
  "\t\t\t\t)\n".
  "@\tIN\tNS\t".$NameServers[0].".".$Domain.".\n".
  "@\tIN\tNS\t".$NameServers[1].".".$Domain.".\n".
  "\tIN\tNS\tserver.zlin.czf.\n\n";
  fputs($File, $Header);

  $Header = '$TTL 86400'."\n".
  "@\tIN\tSOA\t".$NameServers[0]."-ext.".$Domain.".\troot.".$Domain.".	(\n".
  "\t\t\t\t".$Serial."\t; serial\n".
  "\t\t\t\t".$RefreshTime."\t; refresh\n".
  "\t\t\t\t".$RetryTime."\t; retry\n".
  "\t\t\t\t".$ExpireTime."\t; expire\n".
  "\t\t\t\t".$MinimumTime."\t; minimum\n".
  "\t\t\t\t)\n".
  "@\tIN\tNS\t".$NameServers[0]."-ext.".$Domain.".\n";
  "@\tIN\tNS\t".$NameServers[1]."-ext.".$Domain.".\n";
  "\tIN\tNS\tserver.zlin.czf.\n\n";

  fputs($File2, $Header);

  $DbResult = $Database->query('SELECT NetworkInterface.*, NetworkDevice.Name AS DeviceName FROM NetworkInterface JOIN NetworkDevice ON NetworkDevice.Id = NetwordInterface.Device WHERE NetworkInterface.CZFreeIP LIKE "'.$Network.'.%"');
  while($Interface = $DbResult->fetch_assoc())
  {
    $Name = $Interface['DeviceName'];
    if($Interface['Name'] != '') $Name .= '-'.$Interface['Name'];
    $Name = strtolower($Name);
    if(strlen($Name) < 8) $Name .= "\t";
    $IP = explode('.', $Interface['CZFreeIP']);
    fputs($File, $IP[3]."\tIN\tPTR\t".strtolower($Interface['Name']).".".$Domain.".\n");
    fputs($File2, $IP[3]."\tIN\tPTR\t".strtolower($Interface['Name'].'-czfree').".".$Domain.".\n");
  }

  fclose($File);
  fclose($File2);
}

?>
